<?php			

	/**
	 *	Register new user
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
	

	require "inc/includer.inc.php";
	require_once("inc/countries.inc.php");
	
	// Try to extend the max. execution time
	// Works only, if PHP-server is NOT configured for safe-mode
	if(!(boolean)ini_get('safe_mode'))		{
		@set_time_limit(180);
	}
		
	function AddToDatabase()		{
		
		$sql = BuildSQLString();
		// Add Advertisment to Database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		
		if($DB==false)	{
			echo LANG_DBCONNECTERRORCUST;
			die();
		}
		$RetVal = $DB->dbinsert($sql);
		if($RetVal)		{
			LogActions("USRA","User-ID: ".$RetVal." - Username: ".
				$_POST['f_username']." - IP: ".$_SERVER['REMOTE_ADDR'],$RetVal);	
		}
		return $RetVal;
	}


	function BuildSQLString()		{

		// Build string
		$RetVal = "INSERT INTO cf_users ".
			"(userhomepage,usericq,usercreatedate,userlastlogin,username,userpass,userrights,userdeflang,".
			"userblocked,userrealname,useradress1,useradress2,usertitle,userzip,usercity,".
			"usertel,userfax,usermobile,useremail,usercountry,useripaddress,useraim,useryahoo,".
			"userskype,usermsn,userreleased,useremailhtml) VALUES ('".
			$_POST['f_website']."','".$_POST['f_icq']."',now(),now(),'".$_POST['f_username']."','".
			md5($_POST['f_password'])."',1,'".$_POST['f_languageselect']."',".
			"0,'".$_POST['f_name']."','".$_POST['f_address1']."','".$_POST['f_address2']."','".
			$_POST['f_title']."','".$_POST['f_zip']."','".$_POST['f_city']."',".
			"'".$_POST['f_tel']."','".$_POST['f_fax']."','".$_POST['f_mobile']."','".
			$_POST['f_email']."','".$_POST['f_country']."','".$_SERVER['REMOTE_ADDR']."','".
			$_POST['f_aim']."','".$_POST['f_yahoo']."','".$_POST['f_skype']."','".
			$_POST['f_msn']."',".(GetConfig('SEC_REGUSER_OPTIN')?"0":"1").",".(GetConfig('ML_EMAIL_HTML')?"1":"0").")";

		return $RetVal; 	
	}

	//
	// Init
	//
	$UserTest = array( 	"usernametest"=>			true,
						"passwordtest"=>			true,
						"passwordtesttest"=>		true,
						"nametest"=>				true,
						"address1test"=>			true,
						"ziptest"=>					true,
						"citytest"=>				true,
						"countrytest"=>				true,
						"emailtest"=>				true,
						"languageselecttest"=>		true,
						"usertel"=>					true,
						"useremail"=>				true,
						"userfax"=>					true,
						"usermobile"=>				true,
						"userlastlogin"=>			true,
						"touaccepttest"=>			true
	);
	$bError = FALSE;
	$strMessage = "";
	$BreadCrumb = "";
		
	
	// Start display
	$PageTitle = GetPageTitle(LANG_INPTTLNEWUSER);
	include "inc/header.inc.php";
	

	//
	// Process form
	//
	if(isset($_POST['send']) && strtoupper($_POST['send'])=="YES")	{
		
		// Start with checking and converting input
		$_POST['f_website'] = toSafeString($_POST['f_website']);
		$_POST['f_website'] = CropProtocol($_POST['f_website']);
		$_POST['f_icq'] = toSafeString($_POST['f_icq']);
		$_POST['f_aim'] = toSafeString($_POST['f_aim']);
		$_POST['f_yahoo'] = toSafeString($_POST['f_yahoo']);
		$_POST['f_skype'] = toSafeString($_POST['f_skype']);
		$_POST['f_msn'] = toSafeString($_POST['f_msn']);
		$_POST['f_username'] = toSafeString($_POST['f_username']);
		$_POST['f_password'] = toSafeString($_POST['f_password']);
		$_POST['f_passwordtest'] = toSafeString($_POST['f_passwordtest']);
		$_POST['f_name'] = toSafeString($_POST['f_name']);
		$_POST['f_address1'] = toSafeString($_POST['f_address1']);
		$_POST['f_address2'] = toSafeString($_POST['f_address2']);
		$_POST['f_title'] = toSafeString($_POST['f_title']);
		$_POST['f_zip'] = toSafeString($_POST['f_zip']);
		$_POST['f_city'] = toSafeString($_POST['f_city']);
		$_POST['f_tel'] = toSafeString($_POST['f_tel']);
		$_POST['f_fax'] = toSafeString($_POST['f_fax']);
		$_POST['f_mobile'] = toSafeString($_POST['f_mobile']);
		$_POST['f_email'] = toSafeString($_POST['f_email']);
		$_POST['f_country'] = toSafeString($_POST['f_country']);
		
		
		// Form filled and sent, so check it!
		if(empty($_POST['f_username']))		{ $UserTest['usernametest']=false; }
		if(empty($_POST['f_password']))		{ $UserTest['passwordtest']=false; }
		if(empty($_POST['f_passwordtest']))	{ $UserTest['passwordtesttest']=false; }
		if(empty($_POST['f_name']))			{ $UserTest['nametest']=false; }
		//if(empty($_POST['f_address1']))		{ $UserTest['address1test']=false; }
		if(empty($_POST['f_zip']))			{ $UserTest['ziptest']=false; }
		if(empty($_POST['f_city']))			{ $UserTest['citytest']=false; }
		if(empty($_POST['f_country']))		{ $UserTest['countrytest']=false; }
		if(empty($_POST['f_email']))		{ $UserTest['emailtest']=false; }
		if(empty($_POST['f_languageselect']))	{ $UserTest['languageselecttest']=false; }
		if(empty($_POST['f_touaccepted']))	{ $UserTest['touaccepttest']=false; }
			
		foreach($UserTest as $element)	{
			if($element == false)	{ 
				$bError = TRUE; 
				$strMessage = LANG_NEWADMANDATORYERROR; 
			}
		}

		// Check form for plausibility
		// Email vaid?
		if(!$bError)		{
			if (!eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}$",$_POST['f_email']))		{
  				$UserTest['email']=false;
				$bError = TRUE;
				$strMessage = LANG_NEWADEMAILERROR;
			}
  		}	

  		// Password == retyped Password
		if(!$bError)	{

			if($_POST['f_password'] != "SECUREDPASS")	{
				if(($_POST['f_password']!=$_POST['f_passwordtest']))	{
	
					$bError=TRUE;
					$UserTest['passwordtest']=FALSE;
					$UserTest['passwordtesttest']=FALSE;
					$strMessage = LANG_NEWUSERPASSWORDERROR;
				} else {
					$_SESSION['PasswordStored'] = $_POST['f_password'];
					$_POST['f_password'] = "SECUREDPASS";
					$_POST['f_passwordtest'] = "SECUREDPASS";		
				}
			}
		}
		
		// Check if username is long enough >4 chars
		if(!$bError)		{
			
			if((strlen($_POST['f_username'])<=3) || (strlen($_POST['f_username'])>=40))	{
				$bError=TRUE;
				$UserTest['username']=FALSE;
				$strMessage = LANG_NEWUSERUSERNAMETOSHORT;
			}
		}
		
		// Check if Username or password are already in database
		if(!$bError)		{
			$TestArray = CheckUserName(trim($_POST['f_username']), trim($_POST['f_email']));
			if(is_array($TestArray))	{
				// We got an array -> test worked properly	
				if($TestArray['UserNameFound']==TRUE)	{
					$bError = TRUE;
					$UserTest['usernametest']=FALSE;
					$strMessage = LANG_NEWUSERUSERALREADYSTORED;
				} elseif($TestArray['UserEmailFound']==TRUE)	{
					$bError = TRUE;
					$UserTest['emailtest']=FALSE;
					$strMessage = LANG_NEWUSEREMAILALREADYSTORED;
				}
			} else { 
				die("Fatal Error: Could not test validity of username & password");  
			}
			
		}
		
		
		// Check captcha
		if(GetConfig("USE_CAPTCHA") && GetConfig("USE_USERREG_CAPTCHA"))	{
			if(!$bError)	{
				if(!isset($_SESSION['CAPTCHA']) || 
					(sha1(strtoupper($_POST['f_captcha'])) != $_SESSION['CAPTCHA']['SOLUTION']))	{
					
					$ContactTest['captchatest'] = FALSE;
					$bError = TRUE;
					$strMessage = LANG_CAPTCHA_ERROR;
				}			
			}
		}
		
	
		if(!$bError)		{
			
			$_POST['f_password'] = $_SESSION['PasswordStored'];
			
			$RetVal = AddToDatabase();
			if(!$RetVal)	{
				// Problems adding the user to database
				unset($_SESSION['s_UserInfo']);
				$bError = TRUE;
				$strMessage = LANG_NEWUSERADDERROR;
			} else {
				
				unset($_SESSION['PasswordStored']);
				
				if(GetConfig('SEC_REGUSER_OPTIN'))	{

					require_once("inc/postoffice.class.php");
					
					// Send email to user with release code	
					$oPO = new PostOfficeUserOptIn($RetVal);
					$oPO->SetLanguage($_POST['f_languageselect']);
					$oPO->Send();
					
					$strMessage = LANG_NEWUSERADDSUCCESSOPTIN;
					
				} else {
					// Login user, if opt-in is not used
					if($RetVal > 0)		{
						
						// User authentificated	
						$UserInfo = GetUserDetails($RetVal);
						if(!is_array($UserInfo))	{
							// Couldnt user info, so discard all changes
							$_SESSION['s_UserInfo'] = array();
							unset($_SESSION['s_UserInfo']);
						} else {
							$_SESSION['s_UserInfo'] = $UserInfo;
							LogActions("LOG","User logged in - User:".
								$_SESSION['s_UserInfo']['username'], $_SESSION['s_UserInfo']['userid']);	
							UpdateLastLogin($_SESSION['s_UserInfo']['userid']);
						}
					}
					
					$strMessage = LANG_NEWUSERADDSUCCESS;
				}
				
				// Show success page				
				include "templates/".$GLOBALS['ACTIVELANGUAGE']."/success.tpl.php";
				include "inc/footer.inc.php";
				die();
				
			}
		}
	} else {
		// First display
		$_POST['f_languageselect'] = GetConfig('DEFLANG'); 
		$_POST['f_country'] = GetConfig('DEFCOUNTRY');
		
		$_SESSION['PasswordStored'] = "";
		
		if(GetConfig("USE_CAPTCHA") && GetConfig("USE_USERREG_CAPTCHA"))	{
			
			// Create new captcha
			require_once("inc/textcaptcha.class.php");
			
			$oCaptcha = new TextCaptcha();
			$oCaptcha->SetMaxChars(GetConfig("CAPTCHA_CHARS"));
			$oCaptcha->BuildCaptcha();
			$_SESSION['CAPTCHA'] = array( 	"QUESTION"	=> $oCaptcha->GetQuestion(),
											"SOLUTION"	=> sha1(strtoupper($oCaptcha->GetSolution()))	);
		}	
	}
	
	//
	// Display template
	//
	$strLangSelect = GetAvailLang(true, $_POST['f_languageselect']);
	$strCountrySelect = GetCountriesForDropDown($_POST['f_country']);

	$ImgError = "<img src=\"".GetConfig('PD_SCRIPTGRAPHICS')."x.gif\" valign=\"center\">";
	$BreadCrumb =  "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
		"&nbsp;&gt;&nbsp;".LANG_INPTTLNEWUSER;

	// Add captcha
	if(GetConfig("USE_CAPTCHA") && GetConfig("USE_USERREG_CAPTCHA"))		{
		$strCaptcha = $_SESSION['CAPTCHA']['QUESTION'];
	}		
		
	// Include template
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/newuser.tpl.php";
	include "inc/footer.inc.php";

?>