<?php		

	/**
	 *	Select a message to edit
	 * 
	 * 	For Admin use only
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
			

	require "inc/includer.inc.php";
	require_once("inc/admin.inc.php");

	
	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLADMINEDTMSG);
	include "inc/header.inc.php";
		
	$bError = FALSE;
	$strMessage = "";
	$strFilter = "";
	$iMsgID = -1;

	
	//
	// Securitycheck
	//
	if(!isset($_SESSION['admin']) || 
		md5("This_user_is_an_admin_from".$_SERVER['REMOTE_ADDR'])!=$_SESSION['admin'])	{
		
		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php\">";
		include "inc/header.inc.php";
		die();
	}
	
	// Get filter
	if(isset($_SESSION['s_MsgFilter'])	&& !empty($_SESSION['s_MsgFilter']))	{
		$strFilter = $_SESSION['s_MsgFilter'];
	}
		
		
	//
	// Process form
	//
	if(isset($_POST['ready']) && strtoupper($_POST['ready'])=="YES")	{

		if(isset($_POST['f_messagetoedit']))	{
			$iMsgID = (integer)$_POST['f_messagetoedit'];
		}
		
		switch(TRUE)	{
			case isset($_POST['f_filter']):

				// Filter user list
				$_POST['f_filterkey'] = toSafeString($_POST['f_filterkey']);
				if(!empty($_POST['f_filterkey']))	{
					$strFilter = $_POST['f_filterkey'];
					$_SESSION['s_MsgFilter'] = $strFilter;
				}
				break;
			case isset($_POST['f_filterdelete']):
				
				// Delete user filter
				$strFilter = "";
				$_SESSION['s_MsgFilter'] = "";
				unset($_SESSION['s_MsgFilter']);			
			
				break;
			case isset($_POST['f_prolong30']):
			case isset($_POST['f_prolongunlimited']):

				if($iMsgID <= 0)	{
					$bError = TRUE;
					$strMessage = LANG_MSGNOTSELECTED;				
				} else {
					ProlongMessage($iMsgID, (isset($_POST['f_prolongunlimited'])?3600:30));
					$strMessage = LANG_GENERALEDITSUCCESS;
				}
				break;
			case isset($_POST['f_featured']):
				
				if($iMsgID <= 0)	{
					$bError = TRUE;
					$strMessage = LANG_MSGNOTSELECTED;				
				} else {
					ToogleFeatured($iMsgID);
					$strMessage = LANG_GENERALEDITSUCCESS;
				}		
				break;
			case isset($_POST['f_agerest']):	
					if($iMsgID <= 0)	{
					$bError = TRUE;
					$strMessage = LANG_MSGNOTSELECTED;
				} else {
					ToogleAgeRestricted($iMsgID);
					$strMessage = LANG_GENERALEDITSUCCESS;
				}
				break;
			case isset($_POST['f_release']):
			
				// Release
				if($iMsgID<=0)	{
					$strMessage = LANG_MSGNOTSELECTED;
					$bError = TRUE;
				} else {
					ReleaseAd($iMsgID, "", TRUE);
					$strMessage = LANG_GENERALEDITSUCCESS; 
				}
			
				break;
			case isset($_POST['f_delete']):
				
				// Delete ad
				if($iMsgID<=0)	{
					$strMessage = LANG_MSGNOTSELECTED;
					$bError = TRUE;
				} else {
					if(DeleteMessage($iMsgID))	{					
						$strMessage = ParseIn(LANG_MSGDELETESUCCESS,1,0);
					} else {
						$bError = TRUE;
						$strMessage = LANG_DBACCESSERROR;
					}
				}
			
				break;
			case isset($_POST['f_edit']):
				
				// Edit message
				if($iMsgID<=0)	{
					$strMessage = LANG_MSGNOTSELECTED;
					$bError = TRUE;
				} else {
					$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; ".
						"URL=admin_editmessagedetails.php?adid=".$iMsgID."\">";
					include "inc/header.inc.php";
					die();
				}
				break;
		}
	} 

	
	//
	// Display template
	//	
	$OptionList = BuildMessagelistForListField(FALSE, FALSE, $strFilter);
	if($OptionList == false)	{
		$OptionList = "<option value=\"-1\">".LANG_DBEMPTYTABLE."</option>";	
	}
	
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/admin_editmessage.tpl.php";
	include "inc/footer.inc.php";
?>