<?php		

	/**
	 *	Show logfile entries
	 * 
	 * 	For Admin use only
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
	

	require "inc/includer.inc.php";
	require_once("inc/admin.inc.php");
	require "inc/export.class.php";
	
	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLADMINEXPORT);
	include "inc/header.inc.php";
	
	
	$strResultTable = "";
	$strMessage = "";
	$bError = FALSE;

		
	//
	// Securitycheck
	//
	if(!isset($_SESSION['admin']) || 
		md5("This_user_is_an_admin_from".$_SERVER['REMOTE_ADDR'])!=$_SESSION['admin'])	{
		
		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php\">";
		include "inc/header.inc.php";
		die();
	}
	
	
	//
	// Process form
	//
	if(isset($_POST['ready']) && strtoupper($_POST['ready'])=="YES")	{
		
		$oExport = NULL;
		$bTitleRow = FALSE;
		$strFilename = "";
		
		if(isset($_POST['f_exporttype']))	{
			
			if(isset($_POST['f_exportheader']) && strtoupper($_POST['f_exportheader'])=="YES")	{
				$bTitleRow = TRUE;
			} else {
				$bTitleRow = FALSE;
			}
			
			switch(TRUE)	{
				case (strtoupper($_POST['f_exporttype'])=="USERS"):
					$oExport = new UserExport();					
					$strFilename = "export_user.csv";
					break;
				case (strtoupper($_POST['f_exporttype'])=="ADS"):
					$oExport = new AdExport();
					$strFilename = "export_ad.csv";
					break;
			}
			
			if(!is_null($oExport))	{
				$oExport->GetData();
				$oExport->DownloadData($strFilename);
			}
		}

	} else {

	}
	
	//
	// Display template
	//
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/admin_export.tpl.php";	
	include "inc/footer.inc.php";

?>