<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>{DomainName}-Nachricht</title>
<style type="text/css">
body {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-style: normal;
	font-weight: normal;
	background-color: #E6E6E6;
}
a:link, a:visited, a:active {	
	font-weight:bold;
	text-decoration:none;
	color: #FF6600
}
a:hover	{
	font-weight:bold;
	text-decoration:none;
	background-color: #999999;
	color: #FFE6B0;
}
.logo {
	background-color:#cccccc;
	border: 1px solid gray;
	font-weight:bold;
	font-size:24px;
	color:#666666;
	padding:10px; 
}
.content, .commercial {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	text-align:left;
	background-color: #FFE6B0;
	padding: 5px;
	border: 2px dashed #FFCC33;
}
.content table	{
	border: 1px solid black;	
}

.disclaimer	{
	font-size:10px;
	text-align:left;
	padding:3px;
}
.subject	{
	font-family: Arial, Helvetica, sans-serif;
	background-color: #FFCC66;
	font-size: 14px;
	font-weight:bold;
	padding:5px;
	border-bottom: 1px solid gray;
	border-top: 1px solid gray;
	margin-top: 10px;
}
.senderinfo		{
	background-color:#cccccc;
	text-align:right;
	font-size:10px;
	padding:3px;
	border: 1px solid gray;
}
.allover {
	border:1px solid gray;
	background-color: #FFE6B0;
}
</style>
</head>
<body>
	<table width="100%" border="0" cellpadding="5">
	  <tr>
		<td><div align="center">
		  <table width="580" border="0" cellpadding="0" class="allover">
			  <tr>
				<td>
					<div class="logo">Classified Ads </div>
				</td>
			  </tr>
			  <tr>
				<td>
					<div align="left" class="subject">[{DomainName}]: Your user registration </div>
				</td>
			  </tr>
			  <tr>
				<td>
					<div class="content">
					  <p>Dear Mr./Mrs.  {UserRealname},</p>
					  <p>thank you for your registration at  {DomainName}. We are very pleased to welcome you as a new member of our website.</p>
					  <p>To complete your user registration, your account needs to be activated. You can do this by simply clicking the following link:</p>
					  <p><a href="{ReleaseLinkComplete}">Complete user registration and activate account</a></p>
					  <p>After activating your user account, you can use all function of out website - just sign in with your username &quot;{UserName}&quot; and the password you have choosen during registration process. Please keep in mind that the password is case-sensitive.</p>
					  <p>Should the activation not be completed after clicking the link, please enter the following data manually into the fields on the activation page:</p>
					  <table width="100%" border="0">
						<tr>
						  <td width="25%"><strong>Activation page </strong></td>
						  <td><a href="{ReleaseLink}">{ReleaseLink}</a></td>
						</tr>
						<tr>
						  <td width="25%"><strong>User id </strong></td>
						  <td>{UserId}</td>
						</tr>
						<tr>
						  <td width="25%"><strong>Release code </strong></td>
						  <td>{ReleaseCode}</td>
						</tr>
					  </table>
					  <p>Notice: This email is no spam. Your receive it, because you (or maybe someone else) initiated an user registration using your email address. If this registration was not run by yourself and you do not want to get a registered member of this website, not further action of you is required. The registration will be deleted automatically after some time.</p>
					  <p>To go to our website in the future, use this link: <a href="{IndexLink}">Visit ad system </a>.<br>
					  </p>
					  <p>Have fun! <br>
					    <em>Webmaster {DomainName}</em></p>
					</div>
				</td>
			  </tr>
			  <tr>
				<td>
				  <div class="commercial">
					<p><strong>No further information available. </strong><br>
					</p>
				  </div>
				</td>
			  </tr>
			  <tr>
				<td>
					<div class="disclaimer">
					  <p>This email has no commercial purposes. You received it, because you email was used to initiate an user registration at {DomainName}. If this user registration was unintentional (i.E. done by someone unknown), no action of you is required. The registration attempt will be deleted after approx. 2 days. Your data is not stored for any further usage and not submitted to third parties. </p>
				    </div>
				</td>
			  </tr>
			  <tr>
				<td>
					<div class="senderinfo">Sent on {DateTime} from {Program} (V. {Version}) - &copy; 2002-2007 <a href="http://www.projects-and-software.de" target="_blank">cts projects&amp;software</a><br>
Responsible for contentt: {ProviderShortInfo}</div>
				</td>
			  </tr>
			  </table>
		</div></td>
	  </tr>
	</table>
</body>
</html>
