<?php			// MSSSQL-DatabaseEncapsulation

/*	
	class SQLDatabase
	{
		// Membervars
		var $Conn = "";
				
		// Methods
		function SQLDatabase()
		{
			// Constructor
		}
		
		// Displays Errortexts
		function dberror($text,$dead=true)	
		{
			$no = 0;
			$msg= mssql_get_last_message();
			
			// Error occured
			echo "A database error occured: <br>\n[".$text." (Error-No.: ".$no.", Message: ".$msg.")]<BR>\n";
			
			
			// Shoudl the script die
			if($dead)	{
				die();
			} else {
				return $no;					
			}
		}
		
		// Connects to DB-Server and Database
		// dies on failure, returns TRUE on success
		function dbconnect()	
		{
			global $DB_HOST;
			global $DB_USER;
			global $DB_PASS;
			global $DB_NAME;
			
			$conn = @mssql_connect($DB_HOST,$DB_USER,$DB_PASS);
			
			if(!$conn)	{
				$errormsg = "Database connection failed!";
				$this->dberror($errormsg);
			}
			if(!@mssql_select_db($DB_NAME,$conn))	
			{
				$errormsg = "Database connection okay, but datbase itself could not be found!";
				$this->dberror($errormsg);	
			}
			
			$this->Conn = $conn;
			return true;
		}
		
		// Executes a Select-Command on the class-variable $Conn
		function dbselect($sql)
		{
			// Check input
			if(empty($sql))		{return false;}
			if(!eregi("^select",$sql))
			{
				echo "Select-command has wrong format!";
				return false;	
			}
			if(empty($this->Conn))	{return false;}
			$conn = $this->Conn;
			
			// Query it...
			$results = mssql_query($sql,$conn);
			if((!$results) or (empty($results)))	
			{
				return false;	
			}
			
			// Prepare array for return
			$count = 0;
			$data = array();
			while($row = mssql_fetch_array($results))
			{
				$data[$count] = $row;
				$count++;	
			}
			mssql_free_result($results);
			return $data;
			
		}
		
		// Insert into given connection
		// returns database Insert_ID
		function dbinsert($sql="")	
		{
			if(empty($sql))	{return false;}
			if(!eregi("^insert",$sql))
			{
				echo "Insert-command has wrong format!";
				return false;	
			}
			if(empty($this->Conn))	{return false;}
			$conn = $this->Conn;
			$results = mssql_query($sql,$conn);
			if(!$results)	{return false;}
			$results = mssql_insert_id();
			return $results;
			
		}
		
		// Updates Data
		// return number of affected rows or false on an error or problem
		function dbupdate($sql="")	
		{
			if(empty($sql))	{return false;}
			if(!eregi("^update",$sql))
			{
				echo "Update-command has wrong format!";
				return false;	
			}
			if(empty($this->Conn))	{return false;}
			$conn = $this->Conn;
			$results = mssql_query($sql,$conn);
			if(!$results)	{return false;}
			$results = mssql_affected_rows($this->Conn);
			return $results;
		}

		// Deletes Data
		// returns number of affected rows or false on an error or problem
		function dbdelete($sql="")	
		{		
			if(empty($sql))	{return false;}
			if(!eregi("^delete",$sql))
			{
				echo "Delete-command has wrong format!";
				return false;	
			}
			
			if(empty($this->Conn))	{return false;}
			$conn = $this->Conn;
			$results = mssql_query($sql,$conn);
			if(!$results)	{return false;}
		
			$results = mssql_affected_rows($this->Conn);
			return $results;
		}

		function dbtablecreate($sql="")		{
			if(empty($sql))	{return false;}
			if(!eregi("^create",$sql))		
			{
				echo "CREATE TABLE-command has wrong format!";
				return false;
			}
			
			$conn = $this->Conn;
			if(empty($conn))		{return false;}
			
			mssql_query($sql,$conn);
			$result = $this->dberror($text,false);
		
			return $result;
		}
		
		function dbtablealter($sql="")		{
			if(empty($sql))	{return false;}
			
			if(!eregi("^alter",$sql))		
			{
				echo "ALTER TABLE-command has wrong format!";
				return false;
			}
			
			$conn = $this->Conn;
			if(empty($conn))		{return false;}
			
			mssql_query($sql,$conn);
			$result = $this->dberror($text,false);
			
			return $result;
		}

		
	}
	
	*/
?>