<?php		

	/**
	 *	Password lost
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */

	
	require "inc/includer.inc.php";

	//
	// Init variables
	//
	$bError = FALSE;
	$strMessage = "";	
	$BreadCrumb = "";
		
	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLLOSTPW);
	include "inc/header.inc.php";

	
	//
	// Process form
	//
	if(isset($_POST['send']) && strtoupper($_POST['send'])=="YES")	{
		
		$_POST['f_useremail'] = toSafeString($_POST['f_useremail']);

		// Check, if email already logged in
		if(isset($_SESSION['s_UserInfo']) && is_array($_SESSION['s_UserInfo']) && 
			$_SESSION['s_UserInfo']['useremail']==$_POST['f_useremail']) {
			
			$bError=TRUE;
			$strMessage = LANG_LOSTPWALREADYIN;
		}
		
		// Check email
		if (!eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}$",$_POST['f_useremail']) 
			|| empty($_POST['f_useremail']))		{
  			$bError=TRUE;
  			$strMessage = LANG_LOSTPWNOEMAIL;
  		}

  		if(!$bError)	{
			
			// Everything okay, send password
			$iRetVal = SendLoginData($_POST['f_useremail'],
				isset($_SESSION['s_UserInfo']['userdeflang'])?$_SESSION['s_UserInfo']['userdeflang']:"");
			
			if($iRetVal != SUCCESS)		{
				
				$bError = TRUE;
				
				switch($iRetVal)	{
					case ERR_USER_NOT_FOUND:
						$strMessage = LANG_ERR_USER_NOT_FOUND;
						break;
					case ERR_ALTERPASSWORD_TOO_YOUNG:
						$strMessage = LANG_ERR_ALTERPASSWORD_TOO_YOUNG;
						break;
					default:
						$strMessage = LANG_LOSTPWMAILERROR;
						break;
				}
			} else {
				$strMessage = LANG_LOSTPWMAILSUCCESS;
				include "templates/".$GLOBALS['ACTIVELANGUAGE']."/success.tpl.php";
				include "inc/footer.inc.php";
				die();
			}
		} 
	} 

	
	//
	// Display form
	//
	$BreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
		"&nbsp;&gt;&nbsp;".LANG_TTLLOSTPW;

	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/lostpassword.tpl.php";
	include "inc/footer.inc.php";
	
?>